import * as cdk from '@aws-cdk/core';
/**
 * @stability stable
 */
export interface ApplicationProps {
    /**
     * @stability stable
     */
    readonly applicationName: string;
    /**
     * @stability stable
     */
    readonly resourceType: string;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface DeploymentProps {
    /**
     * @stability stable
     */
    readonly applicationProps: ApplicationProps;
    /**
     * @stability stable
     */
    readonly deploymentGroupName: string;
    /**
     * @stability stable
     */
    readonly asgNames: string[];
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly deploymentConfigName: string;
    /**
     * @stability stable
     */
    readonly tgName: string;
}
/**
 * @stability stable
 */
export declare class Deployment extends cdk.Construct {
    /**
     * @stability stable
     */
    constructor(scope: cdk.Construct, id: string, props: DeploymentProps);
    private getApp;
}
